--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -1025,15 +1517,15 @@
             if (nxform != null) {
                 // Must copy in and transform data
                 for (int i = initialNormalIndex; i < vcount * 3; i += 3) {
-                    norms.put(i  , (float) (nxform[0]  * ndata[i] +
-                            nxform[1]  * ndata[i+1] +
-                            nxform[2]  * ndata[i+2]));
-                    norms.put(i+1, (float) (nxform[4]  * ndata[i] +
-                            nxform[5]  * ndata[i+1] +
-                            nxform[6]  * ndata[i+2]));
-                    norms.put(i+2, (float) (nxform[8]  * ndata[i] +
-                            nxform[9]  * ndata[i+1] +
-                            nxform[10] * ndata[i+2]));
+                    norms.put(i, (float) (nxform[0] * ndata[i] +
+                            nxform[1] * ndata[i + 1] +
+                            nxform[2] * ndata[i + 2]));
+                    norms.put(i + 1, (float) (nxform[4] * ndata[i] +
+                            nxform[5] * ndata[i + 1] +
+                            nxform[6] * ndata[i + 2]));
+                    norms.put(i + 2, (float) (nxform[8] * ndata[i] +
+                            nxform[9] * ndata[i + 1] +
+                            nxform[10] * ndata[i + 2]));
                 }
             }
         } else {
@@ -1054,69 +1546,71 @@
                 sarray, strip_len, start_array);
     }
 
-    //----------------------------------------------------------------------
-    // Private helper methods for GeometryArrayRetained
-    //
-
     private void
-            testForInterleavedArrays(int vformat,
-            boolean[] useInterleavedArrays,
-            int[] iaFormat) {
+    testForInterleavedArrays(int vformat,
+                             boolean[] useInterleavedArrays,
+                             int[] iaFormat) {
         if (VERBOSE) System.err.println("JoglPipeline.testForInterleavedArrays()");
         useInterleavedArrays[0] = true;
         switch (vformat) {
-            case GeometryArray.COORDINATES :
-                iaFormat[0] = GL2.GL_V3F; break;
-            case (GeometryArray.COORDINATES | GeometryArray.NORMALS) :
-                iaFormat[0] = GL2.GL_N3F_V3F; break;
-            case (GeometryArray.COORDINATES | GeometryArray.TEXTURE_COORDINATE_2) :
-                iaFormat[0] = GL2.GL_T2F_V3F; break;
-            case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.COLOR) :
-            case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.COLOR | GeometryArray.WITH_ALPHA) :
-                iaFormat[0] = GL2.GL_C4F_N3F_V3F; break;
-            case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.TEXTURE_COORDINATE_2) :
-                iaFormat[0] = GL2.GL_T2F_N3F_V3F; break;
+            case GeometryArray.COORDINATES:
+                iaFormat[0] = GL2.GL_V3F;
+                break;
+            case (GeometryArray.COORDINATES | GeometryArray.NORMALS):
+                iaFormat[0] = GL2.GL_N3F_V3F;
+                break;
+            case (GeometryArray.COORDINATES | GeometryArray.TEXTURE_COORDINATE_2):
+                iaFormat[0] = GL2.GL_T2F_V3F;
+                break;
+            case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.COLOR):
+            case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.COLOR | GeometryArray.WITH_ALPHA):
+                iaFormat[0] = GL2.GL_C4F_N3F_V3F;
+                break;
+            case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.TEXTURE_COORDINATE_2):
+                iaFormat[0] = GL2.GL_T2F_N3F_V3F;
+                break;
             case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.COLOR | GeometryArray.TEXTURE_COORDINATE_2):
             case (GeometryArray.COORDINATES | GeometryArray.NORMALS | GeometryArray.COLOR | GeometryArray.WITH_ALPHA | GeometryArray.TEXTURE_COORDINATE_2):
-                iaFormat[0] = GL2.GL_T2F_C4F_N3F_V3F; break;
+                iaFormat[0] = GL2.GL_T2F_C4F_N3F_V3F;
+                break;
             default:
-                useInterleavedArrays[0] = false; break;
+                useInterleavedArrays[0] = false;
+                break;
         }
     }
 
     private void
-            enableTexCoordPointer(GL2 gl,
-            int texUnit,
-            int texSize,
-            int texDataType,
-            int stride,
-            Buffer pointer) {
+    enableTexCoordPointer(GL2 gl,
+                          int texUnit,
+                          int texSize,
+                          int texDataType,
+                          int stride,
+                          Buffer pointer) {
         if (VERBOSE) System.err.println("JoglPipeline.enableTexCoordPointer()");
         clientActiveTextureUnit(gl, texUnit);
         gl.glEnableClientState(GL2.GL_TEXTURE_COORD_ARRAY);
         gl.glTexCoordPointer(texSize, texDataType, stride, pointer);
     }
 
-	private void disableTexCoordPointer(GL2 gl, int texUnit) {
+    private void disableTexCoordPointer(GL2 gl, int texUnit) {
         if (VERBOSE) System.err.println("JoglPipeline.disableTexCoordPointer()");
         clientActiveTextureUnit(gl, texUnit);
         gl.glDisableClientState(GL2.GL_TEXTURE_COORD_ARRAY);
     }
 
-	private void clientActiveTextureUnit(GL2 gl, int texUnit) {
+    private void clientActiveTextureUnit(GL2 gl, int texUnit) {
         if (VERBOSE) System.err.println("JoglPipeline.clientActiveTextureUnit()");
         if (gl.isExtensionAvailable("GL_VERSION_1_3")) {
             gl.glClientActiveTexture(texUnit + GL.GL_TEXTURE0);
         }
     }
 
-
     private void
-            executeTexture(int texCoordSetMapLen,
-            int texSize, int bstride, int texCoordoff,
-            int[] texCoordSetMapOffset,
-            int numActiveTexUnit,
-            FloatBuffer verts, GL2 gl) {
+    executeTexture(int texCoordSetMapLen,
+                   int texSize, int bstride, int texCoordoff,
+                   int[] texCoordSetMapOffset,
+                   int numActiveTexUnit,
+                   FloatBuffer verts, GL2 gl) {
         if (VERBOSE) System.err.println("JoglPipeline.executeTexture()");
         int tus = 0;  /* texture unit state index */
 
@@ -1124,11 +1618,11 @@
 
             tus = i;
 
-      /*
-       * it's possible thattexture unit state index (tus)
-       * is greater than the texCoordSetMapOffsetLen, in this
-       * case, just disable TexCoordPointer.
-       */
+            /*
+             * it's possible thattexture unit state index (tus)
+             * is greater than the texCoordSetMapOffsetLen, in this
+             * case, just disable TexCoordPointer.
+             */
             if ((tus < texCoordSetMapLen) &&
                     (texCoordSetMapOffset[tus] != -1)) {
                 if (EXTRA_DEBUGGING) {
@@ -1144,7 +1638,7 @@
         }
     }
 
-	private void resetTexture(GL2 gl, JoglContext ctx) {
+    private void resetTexture(GL2 gl, JoglContext ctx) {
         if (VERBOSE) System.err.println("JoglPipeline.resetTexture()");
         /* Disable texture coordinate arrays for all texture units */
         for (int i = 0; i < ctx.getMaxTexCoordSets(); i++) {
@@ -1155,23 +1649,23 @@
     }
 
     private void
-            executeGeometryArray(Context absCtx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean useAlpha,
-            boolean ignoreVertexColors,
-            int startVIndex, int vcount, int vformat,
-            int texCoordSetCount, int[] texCoordSetMap,
-            int texCoordSetMapLen,
-            int[] texCoordSetMapOffset,
-            int numActiveTexUnitState,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            float[] varray, FloatBuffer varrayBuffer,
-            float[] carray, int cDirty) {
+    executeGeometryArray(Context absCtx,
+                         GeometryArrayRetained geo, int geo_type,
+                         boolean isNonUniformScale,
+                         boolean useAlpha,
+                         boolean ignoreVertexColors,
+                         int startVIndex, int vcount, int vformat,
+                         int texCoordSetCount, int[] texCoordSetMap,
+                         int texCoordSetMapLen,
+                         int[] texCoordSetMapOffset,
+                         int numActiveTexUnitState,
+                         int vertexAttrCount, int[] vertexAttrSizes,
+                         float[] varray, FloatBuffer varrayBuffer,
+                         float[] carray, int cDirty) {
         if (VERBOSE) System.err.println("JoglPipeline.executeGeometryArray()");
         JoglContext ctx = (JoglContext) absCtx;
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
         boolean useInterleavedArrays;
         int iaFormat = 0;
@@ -1182,7 +1676,7 @@
         int vAttrStride = 0;
         int bstride = 0, cbstride = 0;
         FloatBuffer verts = null;
-        FloatBuffer clrs  = null;
+        FloatBuffer clrs = null;
         int[] sarray = null;
         int[] start_array = null;
 
@@ -1204,7 +1698,7 @@
             coordoff += 3;
         }
         if ((vformat & GeometryArray.COLOR) != 0) {
-            if ((vformat & GeometryArray.WITH_ALPHA) != 0 ) {
+            if ((vformat & GeometryArray.WITH_ALPHA) != 0) {
                 stride += 4;
                 normoff += 4;
                 coordoff += 4;
@@ -1244,10 +1738,10 @@
             texCoordoff += vAttrStride;
         }
 
-		bstride = stride * Buffers.SIZEOF_FLOAT;
+        bstride = stride * Buffers.SIZEOF_FLOAT;
 
         if (geo_type == GeometryRetained.GEO_TYPE_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_LINE_STRIP_SET) {
             sarray = ((GeometryStripArrayRetained) geo).stripVertexCounts;
             start_array = ((GeometryStripArrayRetained) geo).stripStartOffsetIndices;
@@ -1273,26 +1767,26 @@
             clrs = verts;
         }
 
-		cbstride = cstride * Buffers.SIZEOF_FLOAT;
+        cbstride = cstride * Buffers.SIZEOF_FLOAT;
 
         // Enable normalize for non-uniform scale (which rescale can't handle)
         if (isNonUniformScale) {
             gl.glEnable(GL2.GL_NORMALIZE);
         }
 
-        int startVertex = stride  * startVIndex;
-        int startClrs   = cstride * startVIndex;
+        int startVertex = stride * startVIndex;
+        int startClrs = cstride * startVIndex;
         if (clrs == verts) {
             startClrs += coloroff;
         }
 
         /*** Handle non-indexed strip GeometryArray first *******/
         if (geo_type == GeometryRetained.GEO_TYPE_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_LINE_STRIP_SET) {
             if (ignoreVertexColors || (carray != null) ||
                     ((vformat & GeometryArray.TEXTURE_COORDINATE) != 0 && ((texCoordSetMapLen > 1) ||
-                    (texCoordSetCount > 1)))) {
+                            (texCoordSetCount > 1)))) {
                 useInterleavedArrays = false;
             } else {
                 boolean[] tmp = new boolean[1];
@@ -1371,7 +1865,7 @@
             /******* Handle non-indexed non-striped GeometryArray now *****/
             if (ignoreVertexColors || (carray != null) ||
                     ((vformat & GeometryArray.TEXTURE_COORDINATE) != 0 && ((texCoordSetMapLen > 1) ||
-                    (texCoordSetCount > 1)))) {
+                            (texCoordSetCount > 1)))) {
                 useInterleavedArrays = false;
             } else {
                 boolean[] tmp = new boolean[1];
@@ -1430,11 +1924,19 @@
                     }
                 }
             }
-            switch (geo_type){
-                case GeometryRetained.GEO_TYPE_QUAD_SET : gl.glDrawArrays(GL2.GL_QUADS,     0, vcount); break;
-                case GeometryRetained.GEO_TYPE_TRI_SET  : gl.glDrawArrays(GL.GL_TRIANGLES, 0, vcount); break;
-                case GeometryRetained.GEO_TYPE_POINT_SET: gl.glDrawArrays(GL.GL_POINTS,    0, vcount); break;
-                case GeometryRetained.GEO_TYPE_LINE_SET : gl.glDrawArrays(GL.GL_LINES,     0, vcount); break;
+            switch (geo_type) {
+                case GeometryRetained.GEO_TYPE_QUAD_SET:
+                    gl.glDrawArrays(GL2.GL_QUADS, 0, vcount);
+                    break;
+                case GeometryRetained.GEO_TYPE_TRI_SET:
+                    gl.glDrawArrays(GL.GL_TRIANGLES, 0, vcount);
+                    break;
+                case GeometryRetained.GEO_TYPE_POINT_SET:
+                    gl.glDrawArrays(GL.GL_POINTS, 0, vcount);
+                    break;
+                case GeometryRetained.GEO_TYPE_LINE_SET:
+                    gl.glDrawArrays(GL.GL_LINES, 0, vcount);
+                    break;
             }
         }
 
@@ -1452,7 +1954,6 @@
         }
     }
 
-
     // glLockArrays() is invoked only for indexed geometry, and the
     // vertexCount is guarenteed to be >= 0.
     private void lockArray(GL2 gl, int vertexCount) {
@@ -1468,38 +1969,38 @@
     }
 
     private void
-            executeGeometryArrayVA(Context absCtx,
-            GeometryArrayRetained geo,
-            int geo_type,
-            boolean isNonUniformScale,
-            boolean ignoreVertexColors,
-            int vcount,
-            int vformat,
-            int vdefined,
-            int initialCoordIndex, FloatBuffer fverts, DoubleBuffer dverts,
-            int initialColorIndex, FloatBuffer fclrs, ByteBuffer bclrs,
-            int initialNormalIndex, FloatBuffer norms,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            int[] vertexAttrIndices, FloatBuffer[] vertexAttrData,
-            int texCoordMapLength,
-            int[] texCoordSetMap,
-            int numActiveTexUnit,
-            int[] texindices, int texStride, FloatBuffer[] texCoords,
-            int cdirty,
-            int[] sarray,
-            int strip_len,
-            int[] start_array) {
+    executeGeometryArrayVA(Context absCtx,
+                           GeometryArrayRetained geo,
+                           int geo_type,
+                           boolean isNonUniformScale,
+                           boolean ignoreVertexColors,
+                           int vcount,
+                           int vformat,
+                           int vdefined,
+                           int initialCoordIndex, FloatBuffer fverts, DoubleBuffer dverts,
+                           int initialColorIndex, FloatBuffer fclrs, ByteBuffer bclrs,
+                           int initialNormalIndex, FloatBuffer norms,
+                           int vertexAttrCount, int[] vertexAttrSizes,
+                           int[] vertexAttrIndices, FloatBuffer[] vertexAttrData,
+                           int texCoordMapLength,
+                           int[] texCoordSetMap,
+                           int numActiveTexUnit,
+                           int[] texindices, int texStride, FloatBuffer[] texCoords,
+                           int cdirty,
+                           int[] sarray,
+                           int strip_len,
+                           int[] start_array) {
         JoglContext ctx = (JoglContext) absCtx;
         GLContext context = context(ctx);
-		GL2 gl = context.getGL().getGL2();
+        GL2 gl = context.getGL().getGL2();
 
-        boolean floatCoordDefined  = ((vdefined & GeometryArrayRetained.COORD_FLOAT)    != 0);
-        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE)   != 0);
-        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT)    != 0);
-        boolean byteColorsDefined  = ((vdefined & GeometryArrayRetained.COLOR_BYTE)     != 0);
-        boolean normalsDefined     = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT)   != 0);
-        boolean vattrDefined       = ((vdefined & GeometryArrayRetained.VATTR_FLOAT)    != 0);
-        boolean textureDefined     = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
+        boolean floatCoordDefined = ((vdefined & GeometryArrayRetained.COORD_FLOAT) != 0);
+        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE) != 0);
+        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT) != 0);
+        boolean byteColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_BYTE) != 0);
+        boolean normalsDefined = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT) != 0);
+        boolean vattrDefined = ((vdefined & GeometryArrayRetained.VATTR_FLOAT) != 0);
+        boolean textureDefined = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
 
         // Enable normalize for non-uniform scale (which rescale can't handle)
         if (isNonUniformScale) {
@@ -1511,7 +2012,7 @@
         if (floatCoordDefined) {
             fverts.position(coordoff);
             gl.glVertexPointer(3, GL.GL_FLOAT, 0, fverts);
-        } else if (doubleCoordDefined){
+        } else if (doubleCoordDefined) {
             dverts.position(coordoff);
             gl.glVertexPointer(3, GL2.GL_DOUBLE, 0, dverts);
         }
@@ -1561,7 +2062,7 @@
         if (textureDefined) {
             int texSet = 0;
             for (int i = 0; i < numActiveTexUnit; i++) {
-                if (( i < texCoordMapLength) &&
+                if ((i < texCoordMapLength) &&
                         ((texSet = texCoordSetMap[i]) != -1)) {
                     FloatBuffer buf = texCoords[texSet];
                     buf.position(texStride * texindices[texSet]);
@@ -1577,7 +2078,7 @@
         }
 
         if (geo_type == GeometryRetained.GEO_TYPE_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_LINE_STRIP_SET) {
             int primType = 0;
             switch (geo_type) {
@@ -1601,11 +2102,19 @@
                 }
             }
         } else {
-            switch (geo_type){
-                case GeometryRetained.GEO_TYPE_QUAD_SET  : gl.glDrawArrays(GL2.GL_QUADS, 0, vcount);     break;
-                case GeometryRetained.GEO_TYPE_TRI_SET   : gl.glDrawArrays(GL.GL_TRIANGLES, 0, vcount); break;
-                case GeometryRetained.GEO_TYPE_POINT_SET : gl.glDrawArrays(GL.GL_POINTS, 0, vcount);    break;
-                case GeometryRetained.GEO_TYPE_LINE_SET  : gl.glDrawArrays(GL.GL_LINES, 0, vcount);     break;
+            switch (geo_type) {
+                case GeometryRetained.GEO_TYPE_QUAD_SET:
+                    gl.glDrawArrays(GL2.GL_QUADS, 0, vcount);
+                    break;
+                case GeometryRetained.GEO_TYPE_TRI_SET:
+                    gl.glDrawArrays(GL.GL_TRIANGLES, 0, vcount);
+                    break;
+                case GeometryRetained.GEO_TYPE_POINT_SET:
+                    gl.glDrawArrays(GL.GL_POINTS, 0, vcount);
+                    break;
+                case GeometryRetained.GEO_TYPE_LINE_SET:
+                    gl.glDrawArrays(GL.GL_LINES, 0, vcount);
+                    break;
             }
         }
 
@@ -1625,31 +2134,45 @@
 
     private String getVertexDescription(int vformat) {
         String res = "";
-        if ((vformat & GeometryArray.COORDINATES)          != 0) res += "COORDINATES ";
-        if ((vformat & GeometryArray.NORMALS)              != 0) res += "NORMALS ";
-        if ((vformat & GeometryArray.COLOR)                != 0) res += "COLOR ";
-        if ((vformat & GeometryArray.WITH_ALPHA)           != 0) res += "(WITH_ALPHA) ";
-        if ((vformat & GeometryArray.TEXTURE_COORDINATE)   != 0) res += "TEXTURE_COORDINATE ";
+        if ((vformat & GeometryArray.COORDINATES) != 0) res += "COORDINATES ";
+        if ((vformat & GeometryArray.NORMALS) != 0) res += "NORMALS ";
+        if ((vformat & GeometryArray.COLOR) != 0) res += "COLOR ";
+        if ((vformat & GeometryArray.WITH_ALPHA) != 0) res += "(WITH_ALPHA) ";
+        if ((vformat & GeometryArray.TEXTURE_COORDINATE) != 0) res += "TEXTURE_COORDINATE ";
         if ((vformat & GeometryArray.TEXTURE_COORDINATE_2) != 0) res += "(2) ";
         if ((vformat & GeometryArray.TEXTURE_COORDINATE_3) != 0) res += "(3) ";
         if ((vformat & GeometryArray.TEXTURE_COORDINATE_4) != 0) res += "(4) ";
-        if ((vformat & GeometryArray.VERTEX_ATTRIBUTES)    != 0) res += "VERTEX_ATTRIBUTES ";
+        if ((vformat & GeometryArray.VERTEX_ATTRIBUTES) != 0) res += "VERTEX_ATTRIBUTES ";
         return res;
     }
 
     private String getGeometryDescription(int geo_type) {
         switch (geo_type) {
-            case GeometryRetained.GEO_TYPE_TRI_STRIP_SET : return "GEO_TYPE_TRI_STRIP_SET";
-            case GeometryRetained.GEO_TYPE_TRI_FAN_SET   : return "GEO_TYPE_TRI_FAN_SET";
-            case GeometryRetained.GEO_TYPE_LINE_STRIP_SET: return "GEO_TYPE_LINE_STRIP_SET";
-            case GeometryRetained.GEO_TYPE_QUAD_SET      : return "GEO_TYPE_QUAD_SET";
-            case GeometryRetained.GEO_TYPE_TRI_SET       : return "GEO_TYPE_TRI_SET";
-            case GeometryRetained.GEO_TYPE_POINT_SET     : return "GEO_TYPE_POINT_SET";
-            case GeometryRetained.GEO_TYPE_LINE_SET      : return "GEO_TYPE_LINE_SET";
-            default: return "(unknown " + geo_type + ")";
+            case GeometryRetained.GEO_TYPE_TRI_STRIP_SET:
+                return "GEO_TYPE_TRI_STRIP_SET";
+            case GeometryRetained.GEO_TYPE_TRI_FAN_SET:
+                return "GEO_TYPE_TRI_FAN_SET";
+            case GeometryRetained.GEO_TYPE_LINE_STRIP_SET:
+                return "GEO_TYPE_LINE_STRIP_SET";
+            case GeometryRetained.GEO_TYPE_QUAD_SET:
+                return "GEO_TYPE_QUAD_SET";
+            case GeometryRetained.GEO_TYPE_TRI_SET:
+                return "GEO_TYPE_TRI_SET";
+            case GeometryRetained.GEO_TYPE_POINT_SET:
+                return "GEO_TYPE_POINT_SET";
+            case GeometryRetained.GEO_TYPE_LINE_SET:
+                return "GEO_TYPE_LINE_SET";
+            default:
+                return "(unknown " + geo_type + ")";
         }
     }
 
+    // ---------------------------------------------------------------------
+
+    //
+    // ColoringAttributesRetained methods
+    //
+
     private void resetVertexAttrs(GL gl, JoglContext ctx, int vertexAttrCount) {
         // Disable specified vertex attr arrays
         for (int i = 0; i < vertexAttrCount; i++) {
@@ -1661,27 +2184,27 @@
     // ---------------------------------------------------------------------
 
     //
-    // IndexedGeometryArrayRetained methods
+    // DirectionalLightRetained methods
     //
 
     // by-copy or interleaved, by reference, Java arrays
     @Override
     void executeIndexedGeometry(Context ctx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean useAlpha,
-            boolean ignoreVertexColors,
-            int initialIndexIndex,
-            int indexCount,
-            int vertexCount, int vformat,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            int texCoordSetCount, int[] texCoordSetMap,
-            int texCoordSetMapLen,
-            int[] texCoordSetOffset,
-            int numActiveTexUnitState,
-            float[] varray, float[] carray,
-            int cdirty,
-            int[] indexCoord) {
+                                GeometryArrayRetained geo, int geo_type,
+                                boolean isNonUniformScale,
+                                boolean useAlpha,
+                                boolean ignoreVertexColors,
+                                int initialIndexIndex,
+                                int indexCount,
+                                int vertexCount, int vformat,
+                                int vertexAttrCount, int[] vertexAttrSizes,
+                                int texCoordSetCount, int[] texCoordSetMap,
+                                int texCoordSetMapLen,
+                                int[] texCoordSetOffset,
+                                int numActiveTexUnitState,
+                                float[] varray, float[] carray,
+                                int cdirty,
+                                int[] indexCoord) {
         if (VERBOSE) System.err.println("JoglPipeline.executeIndexedGeometry()");
 
         executeIndexedGeometryArray(ctx, geo, geo_type,
@@ -1699,20 +2222,20 @@
     // interleaved, by reference, nio buffer
     @Override
     void executeIndexedGeometryBuffer(Context ctx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean useAlpha,
-            boolean ignoreVertexColors,
-            int initialIndexIndex,
-            int indexCount,
-            int vertexCount, int vformat,
-            int texCoordSetCount, int[] texCoordSetMap,
-            int texCoordSetMapLen,
-            int[] texCoordSetOffset,
-            int numActiveTexUnitState,
-            FloatBuffer vdata, float[] carray,
-            int cDirty,
-            int[] indexCoord) {
+                                      GeometryArrayRetained geo, int geo_type,
+                                      boolean isNonUniformScale,
+                                      boolean useAlpha,
+                                      boolean ignoreVertexColors,
+                                      int initialIndexIndex,
+                                      int indexCount,
+                                      int vertexCount, int vformat,
+                                      int texCoordSetCount, int[] texCoordSetMap,
+                                      int texCoordSetMapLen,
+                                      int[] texCoordSetOffset,
+                                      int numActiveTexUnitState,
+                                      FloatBuffer vdata, float[] carray,
+                                      int cDirty,
+                                      int[] indexCoord) {
         if (VERBOSE) System.err.println("JoglPipeline.executeIndexedGeometryBuffer()");
 
         executeIndexedGeometryArray(ctx, geo, geo_type,
@@ -1725,37 +2248,44 @@
                 cDirty, indexCoord);
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // PointLightRetained methods
+    //
+
     // non interleaved, by reference, Java arrays
     @Override
     void executeIndexedGeometryVA(Context ctx,
-            GeometryArrayRetained geo, int geo_type,
-            boolean isNonUniformScale,
-            boolean ignoreVertexColors,
-            int initialIndexIndex,
-            int validIndexCount,
-            int vertexCount,
-            int vformat,
-            int vdefined,
-            float[] vfcoords, double[] vdcoords,
-            float[] cfdata, byte[] cbdata,
-            float[] ndata,
-            int vertexAttrCount, int[] vertexAttrSizes,
-            float[][] vertexAttrData,
-            int texCoordMapLength,
-            int[] texcoordoffset,
-            int numActiveTexUnitState,
-            int texStride, Object[] texCoords,
-            int cdirty,
-            int[] indexCoord) {
+                                  GeometryArrayRetained geo, int geo_type,
+                                  boolean isNonUniformScale,
+                                  boolean ignoreVertexColors,
+                                  int initialIndexIndex,
+                                  int validIndexCount,
+                                  int vertexCount,
+                                  int vformat,
+                                  int vdefined,
+                                  float[] vfcoords, double[] vdcoords,
+                                  float[] cfdata, byte[] cbdata,
+                                  float[] ndata,
+                                  int vertexAttrCount, int[] vertexAttrSizes,
+                                  float[][] vertexAttrData,
+                                  int texCoordMapLength,
+                                  int[] texcoordoffset,
+                                  int numActiveTexUnitState,
+                                  int texStride, Object[] texCoords,
+                                  int cdirty,
+                                  int[] indexCoord) {
         if (VERBOSE) System.err.println("JoglPipeline.executeIndexedGeometryVA()");
 
-        boolean floatCoordDefined  = ((vdefined & GeometryArrayRetained.COORD_FLOAT)    != 0);
-        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE)   != 0);
-        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT)    != 0);
-        boolean byteColorsDefined  = ((vdefined & GeometryArrayRetained.COLOR_BYTE)     != 0);
-        boolean normalsDefined     = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT)   != 0);
-        boolean vattrDefined       = ((vdefined & GeometryArrayRetained.VATTR_FLOAT)    != 0);
-        boolean textureDefined     = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
+        boolean floatCoordDefined = ((vdefined & GeometryArrayRetained.COORD_FLOAT) != 0);
+        boolean doubleCoordDefined = ((vdefined & GeometryArrayRetained.COORD_DOUBLE) != 0);
+        boolean floatColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_FLOAT) != 0);
+        boolean byteColorsDefined = ((vdefined & GeometryArrayRetained.COLOR_BYTE) != 0);
+        boolean normalsDefined = ((vdefined & GeometryArrayRetained.NORMAL_FLOAT) != 0);
+        boolean vattrDefined = ((vdefined & GeometryArrayRetained.VATTR_FLOAT) != 0);
+        boolean textureDefined = ((vdefined & GeometryArrayRetained.TEXCOORD_FLOAT) != 0);
 
         FloatBuffer fverts = null;
         DoubleBuffer dverts = null;
@@ -1778,7 +2308,7 @@
         int[] sarray = null;
         int strip_len = 0;
         if (geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_STRIP_SET ||
-                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET   ||
+                geo_type == GeometryRetained.GEO_TYPE_INDEXED_TRI_FAN_SET ||
                 geo_type == GeometryRetained.GEO_TYPE_INDEXED_LINE_STRIP_SET) {
             sarray = ((IndexedGeometryStripArrayRetained) geo).stripIndexCounts;
             strip_len = sarray.length;
